//////////////////////////////////////////////////////////////////////////////////
// Dimzel version 0.1 by Eikon (eikon@carolina.rr.com)
// written in Dev-C++ 4.0 (http://prdownloads.sourceforge.net/dev-cpp/devcpp4.zip)
// Featured in the Blitz to C: A Text Adventure Tutorial at www.BlitzCoder.com
// Address goes here
//////////////////////////////////////////////////////////////////////////////////
                                                                                // Includes
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
                                                                                // Defines
#define s_Width  80                                                             //   Screen Width
#define s_Height 25                                                             //   Screen Height
                                                                                // Declarations
HANDLE hInput, hOutput;                                                         // Input & Output Handles
int rnd;
CHAR_INFO s_Buffer[s_Width * s_Height];                                         // Char Buffer                                                                                // Rect Data Type
COORD     p_Pos = {0, 0};                                                       // Player Position Coord
char *strstat[3] = { "", "", "" };
char score[] = "25", turns[] = "0", *tmp_Stat[] = { "" };                                                                               // Function Prototypes
char tmp_Col;

void DrawMap(CHAR_INFO s_Buffer[], int X, int Y);                               //   Draw Map Function
void GenerateMap(int Type);
void Stats();                                                                   //   Status Function
void Status(int Mode);                                                          //   Output Function
void Text(char *szText, int X, int Y, WORD color);                              //   Text Function
BOOL p_Input(CHAR_INFO s_Buffer[], COORD *Pos);                                 //   Player Input

int main()                                                                      // Main
{
    unsigned long game_Timer;

    tmp_Stat[0] = "Welcome to Dimzel.";
    hOutput = GetStdHandle(STD_OUTPUT_HANDLE);			                        // OUTPUT handle
	hInput = GetStdHandle(STD_INPUT_HANDLE);                                    // INPUT handle
    SetConsoleMode(hInput, ENABLE_PROCESSED_INPUT);                             // Disable Mouse
  	srand(GetTickCount());                                                      // Seed Random

    GenerateMap(1); Status(1);                                                  // Generate Forest
    DrawMap(s_Buffer, p_Pos.X, p_Pos.Y);                                        // Initial Render
    Stats(); Status(2);                                                         // Load Welcome Msg
    while(1)
    {
        if(p_Input(s_Buffer, &p_Pos)) {
            DrawMap(s_Buffer, p_Pos.X, p_Pos.Y);                                // Render Map
            Stats();                                                            // Status
            Status(2);                                                          // Refresh Stats
            SetConsoleCursorPosition(hOutput, p_Pos);
        }
    }
    return 0;
}

void Status(int Mode)
{
    if(Mode == 1) {
        strstat[2] = strstat[1];
        strstat[1] = strstat[0];
        strstat[0] = tmp_Stat[0];
    }
    else {
        Text(strstat[2], 1, 22, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY);
        Text(strstat[1], 1, 23,  FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY);
        Text(strstat[0], 1, 24,  FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY);
    }
}

void DrawMap(CHAR_INFO s_Buffer[], int X, int Y)
{
	SMALL_RECT drawRect = {0, 0, s_Width - 1, s_Height - 1};                    // Rect Structure
	COORD bufferSize = {s_Width , s_Height};                                    // Screen Size Coord
    COORD s_Top = {0, 0};                                                       // Screen Top + Left

                                                                                // Render Player
	s_Buffer[X + Y * s_Width].Char.AsciiChar = 1;
    s_Buffer[X + Y * s_Width].Attributes = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY;

    WriteConsoleOutput(hOutput, s_Buffer, bufferSize, s_Top, &drawRect);        // Blit to Screen
}

BOOL p_Input(CHAR_INFO s_Buffer[], COORD *Pos)                                  // Player Input
{													
	INPUT_RECORD InputRecord;							                        // Input Record Struct
	COORD old_Pos = *Pos;
	DWORD Events=0;
	BOOL bMoved = FALSE;
    char tmp_Char;

	ReadConsoleInput(hInput, &InputRecord, 1, &Events);

	if(InputRecord.EventType == KEY_EVENT) {                                    // Key Event
		if(InputRecord.Event.KeyEvent.wVirtualKeyCode == VK_LEFT) {               // Left
		    if(Pos->X > 0) {
                Pos->X--; bMoved = TRUE;
            }
        }
        else if(InputRecord.Event.KeyEvent.wVirtualKeyCode == VK_RIGHT) {         // Right
			if(Pos->X < (65 - 1)) {
    			Pos->X++; bMoved = TRUE;
            }
        }
		else if(InputRecord.Event.KeyEvent.wVirtualKeyCode == VK_UP) {          // Up
			if(Pos->Y > 0) {
				Pos->Y--; bMoved = TRUE;
            }
        }
		else if(InputRecord.Event.KeyEvent.wVirtualKeyCode == VK_DOWN ) {       // Down
  		    if(Pos->Y < (21 - 1)) {
				Pos->Y++; bMoved = TRUE;
            }
        }
		else if(InputRecord.Event.KeyEvent.wVirtualKeyCode == VK_ESCAPE) {      // Escape
			exit(0);
        }
	}
	
	FlushConsoleInputBuffer(hInput);

	if(bMoved) {
        tmp_Char = s_Buffer[Pos->X + Pos->Y * s_Width].Char.AsciiChar;// == '*'
		if((tmp_Char == '*') || (tmp_Char == 15)) {                             // Trees
            rnd = ((rand() % 100) + 1);
            if(rnd == 49) {
                tmp_Stat[0] = "You notice a few leaves fall from the tree."; Status(1);
            }
            else if(rnd == 50) {
                tmp_Stat[0] = "You notice rand gold hidden in this tree."; Status(1);
            }
            else if(rnd == 51) {
                tmp_Stat[0] = "You see two eyes peering at you from inside the tree."; Status(1);
            }
            *Pos = old_Pos;
        }
        else if(tmp_Char == '.') {
   			s_Buffer[old_Pos.X + old_Pos.Y * s_Width].Char.AsciiChar = ' ';
            s_Buffer[old_Pos.X + old_Pos.Y * s_Width].Attributes = 0;//FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
            tmp_Col = '.';
        }
		else {                                                                  // Collision
            if(tmp_Col == '.') {
    			s_Buffer[old_Pos.X + old_Pos.Y * s_Width].Char.AsciiChar = tmp_Col;
                s_Buffer[old_Pos.X + old_Pos.Y * s_Width].Attributes = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
                tmp_Col = ' ';

            }
            else {
    			s_Buffer[old_Pos.X + old_Pos.Y * s_Width].Char.AsciiChar = ' ';
                s_Buffer[old_Pos.X + old_Pos.Y * s_Width].Attributes = 0;//FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
            }
        }
		return TRUE;
	}
	return TRUE;
}

void Stats()
{
    Text(":", 68, 1, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_INTENSITY);
    Text(score, 70, 1, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY);
}

void GenerateMap(int Type)
{
    int x = 0, y = 0;
    COORD     s_Size = {65, 21};                                                // W/H Coord
    COORD tmp_C = { 67, 1 };

    for(y = 0; y < s_Size.Y; y++)                                               //   Y Iteration
    {
        for(x = 0; x < s_Size.X; x++)                                           //   X Iteration
        {
            rnd = ((rand() % 14) + 1);
            if (rnd == 1) {                                                     // Dark Green Bush
   				s_Buffer[x + y * s_Width].Char.AsciiChar = '*';
	    		s_Buffer[x + y * s_Width].Attributes = FOREGROUND_GREEN;
            }
            else if (rnd == 2) {                                                // Green Bush
  				s_Buffer[x + y * s_Width].Char.AsciiChar = 15;
        		s_Buffer[x + y * s_Width].Attributes = FOREGROUND_GREEN | FOREGROUND_INTENSITY;
            }
            else if (rnd == 3) {                                                // Grass
			    s_Buffer[x + y * s_Width].Char.AsciiChar = '.';
  			    s_Buffer[x + y * s_Width].Attributes = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
            }
            else {                                                              // Empty Space
				s_Buffer[x + y * s_Width].Char.AsciiChar = ' ';
  				s_Buffer[x + y * s_Width].Attributes = 0;
            }
        }
    }

    s_Buffer[tmp_C.X + tmp_C.Y * 80].Char.AsciiChar = 3;                        // Heart
    s_Buffer[tmp_C.X + tmp_C.Y * 80].Attributes = FOREGROUND_RED | FOREGROUND_INTENSITY;
    tmp_C.Y = 21;
    for(tmp_C.X = 1; tmp_C.X < 65; tmp_C.X++)
    {
        s_Buffer[tmp_C.X + tmp_C.Y * 80].Char.AsciiChar = 196;
        s_Buffer[tmp_C.X + tmp_C.Y * 80].Attributes = FOREGROUND_BLUE | FOREGROUND_INTENSITY;
    }
    tmp_C.X = 65;
    for(tmp_C.Y = 0; tmp_C.Y < 21; tmp_C.Y++)
    {
        s_Buffer[tmp_C.X + tmp_C.Y * 80].Char.AsciiChar = 179;
        s_Buffer[tmp_C.X + tmp_C.Y * 80].Attributes = FOREGROUND_BLUE | FOREGROUND_INTENSITY;
    }
    for(tmp_C.Y = 22; tmp_C.Y < 25; tmp_C.Y++)
    {
        s_Buffer[0 + tmp_C.Y * 80].Char.AsciiChar = 179;
        s_Buffer[0 + tmp_C.Y * 80].Attributes = FOREGROUND_BLUE | FOREGROUND_INTENSITY;
    }
    s_Buffer[0 + 21 * 80].Char.AsciiChar = 218;
    s_Buffer[0 + 21 * 80].Attributes = FOREGROUND_BLUE | FOREGROUND_INTENSITY;
    s_Buffer[65 + 21 * 80].Char.AsciiChar = 217;
    s_Buffer[65 + 21 * 80].Attributes = FOREGROUND_BLUE | FOREGROUND_INTENSITY;
}

void Text(char *szText, int X, int Y, WORD color)
{
    COORD  s_Pos =  {X, Y};
    WORD   *colorBuf = NULL;
    DWORD  dwResult = 0;
    int    length = 0;
    int    i = 0;

    if(szText == NULL)
        return;

    length = strlen(szText);
    colorBuf = (WORD*)malloc(sizeof(WORD) * length);

    for(i=0; i < length; i++)
    {
        colorBuf[i] = color;
    }

    WriteConsoleOutputAttribute(hOutput, colorBuf, length, s_Pos, &dwResult);
    WriteConsoleOutputCharacter(hOutput, szText, length, s_Pos, &dwResult);
    free(colorBuf);
    colorBuf = NULL;
}

